# -*- coding: utf-8 -*-
"""
Created on Tue Jan  7 13:43:00 2020

「Scikit-Learnの識別器をループで一気に適用させる」
https://newtechnologylifestyle.net/scikit-learn-ikkatu/

@author: y8133
"""

#各種ライブラリのImport
import pandas as pd
# import numpy as np
# import matplotlib.pyplot as plt
#%matplotlib inline

#scikit-learnよりあやめのデータを抽出する
# from sklearn import datasets
# data = datasets.load_iris()

#あやめのデータ（説明変数）をdataXに格納する
# dataX = pd.DataFrame(data=data.data,columns=data.feature_names)

#あやめのデータ（目的変数）をdataYに格納する
# dataY = pd.DataFrame(data=data.target)
# dataY = dataY.rename(columns={0: 'Species'})

# データの読み込み
data = pd.read_csv("FeatureValue/ESD_All_state_onehot.csv", encoding="utf-8")

# データをラベル（目的関数）と入力データ（説明関数）に分離する
dataY = data.loc[:,"State"]
dataX = data.loc[:,["0-1kHz","1-2kHz","2-3kHz","3-4kHz","4-5kHz","5-6kHz","6-7kHz","7-8kHz","8-9kHz","9-10kHz","10-11kHz","11-12kHz","12-13kHz","13-14kHz","14-15kHz","15-16kHz","16-17kHz","17-18kHz","18-19kHz","19-20kHz","20-21kHz","21-22kHz"]]

#データの分割を行う（訓練用データ 0.8 評価用データ 0.2）
from sklearn.model_selection import train_test_split
X_train, X_test, Y_train, Y_test = train_test_split(dataX, dataY, test_size=0.2)

from sklearn.linear_model import LogisticRegression
from sklearn.neighbors import KNeighborsClassifier
from sklearn.tree import DecisionTreeClassifier
from sklearn.svm import SVC
from sklearn.ensemble import RandomForestClassifier
from sklearn.linear_model import Perceptron
from sklearn.neural_network import MLPClassifier

#機械学習モデルをリストに格納
models = []
models.append(("ロジスティック回帰","LogisticRegression",LogisticRegression()))
models.append(("k近傍法","k-Nearest Neighbors",KNeighborsClassifier()))
models.append(("決定木","Decision Tree",DecisionTreeClassifier()))
models.append(("サポートベクターマシン(線形)","Support Vector Machine(linear)",SVC(kernel='linear')))
models.append(("サポートベクターマシン(非線形)","Support Vector Machine(rbf)",SVC(kernel='rbf')))
models.append(("ランダムフォレスト","Random Forest",RandomForestClassifier()))
models.append(("パーセプトロン","Perceptron",Perceptron()))
models.append(("多層パーセプトロン","Multilayer perceptron",MLPClassifier()))

names_jp = []
names_en = []
results = []
for name_jp,name_en,model in models:
    
    print(model.fit(X_train,Y_train),"\n")
    
    names_jp.append(name_jp)
    names_en.append(name_en)
    results.append(model.score(X_test,Y_test))
    
list_df = pd.DataFrame( columns=['識別子','識別子(英名)','スコア'] )

for i in range(len(names_jp)):
    list_df = list_df.append( pd.Series( [names_jp[i],names_en[i],results[i]], index=list_df.columns ), ignore_index=True)

"""分類器一覧 https://tutorialmore.com/questions-139715.htm """
# from sklearn.tree import ExtraTreeClassifier
# from sklearn.tree import DecisionTreeClassifier
# from sklearn.svm.classes import OneClassSVM
# from sklearn.neural_network.multilayer_perceptron import MLPClassifier
# from sklearn.neighbors.classification import RadiusNeighborsClassifier
# from sklearn.neighbors.classification import KNeighborsClassifier
# from sklearn.multioutput import ClassifierChain
# from sklearn.multioutput import MultiOutputClassifier
# from sklearn.multiclass import OutputCodeClassifier
# from sklearn.multiclass import OneVsOneClassifier
# from sklearn.multiclass import OneVsRestClassifier
# from sklearn.linear_model.stochastic_gradient import SGDClassifier
# from sklearn.linear_model.ridge import RidgeClassifierCV
# from sklearn.linear_model.ridge import RidgeClassifier
# from sklearn.linear_model.passive_aggressive import PassiveAggressiveClassifier    
# from sklearn.gaussian_process.gpc import GaussianProcessClassifier
# from sklearn.ensemble.voting_classifier import VotingClassifier
# from sklearn.ensemble.weight_boosting import AdaBoostClassifier
# from sklearn.ensemble.gradient_boosting import GradientBoostingClassifier
# from sklearn.ensemble.bagging import BaggingClassifier
# from sklearn.ensemble.forest import ExtraTreesClassifier
# from sklearn.ensemble.forest import RandomForestClassifier
# from sklearn.naive_bayes import BernoulliNB
# from sklearn.calibration import CalibratedClassifierCV
# from sklearn.naive_bayes import GaussianNB
# from sklearn.semi_supervised import LabelPropagation
# from sklearn.semi_supervised import LabelSpreading
# from sklearn.discriminant_analysis import LinearDiscriminantAnalysis
# from sklearn.svm import LinearSVC
# from sklearn.linear_model import LogisticRegression
# from sklearn.linear_model import LogisticRegressionCV
# from sklearn.naive_bayes import MultinomialNB  
# from sklearn.neighbors import NearestCentroid
# from sklearn.svm import NuSVC
# from sklearn.linear_model import Perceptron
# from sklearn.discriminant_analysis import QuadraticDiscriminantAnalysis
# from sklearn.svm import SVC
# from sklearn.mixture import DPGMM
# from sklearn.mixture import GMM 
# from sklearn.mixture import GaussianMixture
# from sklearn.mixture import VBGMM